//charset "utf-8"
;


var wpr={};wpr.ready=function(settings){


	wpr = {


		canvas	: new fabric.Canvas('canvas', { width:1000, height:2500 }),


		viewbox	: (function(){var w={

			top		: window.pageYOffset,

			height	: window.innerHeight,

			scroll	: function(e) {

				var n = window.pageYOffset;

				wpr.viewbox.top = n;
				document.getElementById('right').style.marginTop = n + 'px';
				wpr.modal.orient(n,window.innerHeight);

			},

			resize	: function(e) {

				var n = window.innerHeight;

				wpr.viewbox.height = n;
				wpr.modal.orient(window.pageYOffset,n);

			}

		};return w})(),


		field	: (function(){var w={

			picture	: {

				change	: function(e) {

					var reader = new FileReader();

					reader.readAsDataURL(e.target.files[0]);
					reader.onload = function(event){
						fabric.Image.fromURL(event.target.result, function(obj) {
							wpr.tool.picture.obj = obj;
							wpr.button.picture.click();
						}, {
							originX	: 'center',
							originY	: 'center',
							top		: wpr.viewbox.top + wpr.viewbox.height/2-62,
							left	: 500,
							hasRotatingPoint	: false
						});
					};
				}

			}

		};return w})(),


		button	: (function(){var w={

			picture	: {

				click	: function(e) {

					var picture = wpr.tool.picture;
						obj = picture.obj;

					if(obj) {

						var layer = picture.layer,
							h = layer.length;

						wpr.canvas.add(obj);

						obj.moveTo(wpr.tool.frame.layer.length + wpr.tool.line.layer.length + h);

						layer.push(obj);

						wpr.modal.fade(true);

					};

				}

			}

		};return w})(),


		action	: (function(){var w={

			delete	: function(e) {

				if(e.keyCode == 46 || e.type == 'click') {

					var canvas = wpr.canvas,
						obj = canvas.getActiveObject(),
						grp = canvas.getActiveGroup();

					if(obj/* && window.confirm('Вы действительно хотите удалить выделенный объект?')*/) {

						wpr.tool.delete(obj);

					} else if(grp && window.confirm('Вы действительно хотите удалить выделенные объекты ('+grp.size()+')?')) {

						grp.forEachObject(function(obj){
							wpr.tool.delete(obj);
						});
						canvas.discardActiveGroup();

					};
					canvas.renderAll();
					return false;
				};
				return;
			},

			move	: {
				up	: function(e) {

					var canvas = wpr.canvas,
						obj = canvas.getActiveObject(),
						grp = canvas.getActiveGroup();

					if(obj) {

						wpr.tool.move.up(obj);

					}/* else if(grp) {

						grp.forEachObject(function(obj){
							wpr.tool.move.up(obj);
						});
						canvas.discardActiveGroup();

					}*/;

				},
				down	: function(e) {

					var canvas = wpr.canvas,
						obj = canvas.getActiveObject(),
						grp = canvas.getActiveGroup();

					if(obj) {

						wpr.tool.move.down(obj);

					}/* else if(grp) {

						grp.forEachObject(function(obj){
							wpr.tool.move.down(obj);
						});
						canvas.discardActiveGroup();

					}*/;

				},
				top	: function(e) {

					var canvas = wpr.canvas,
						obj = canvas.getActiveObject(),
						grp = canvas.getActiveGroup();

					if(obj) {

						wpr.tool.move.top(obj);

					}/* else if(grp) {

						grp.forEachObject(function(obj){
							wpr.tool.move.top(obj);
						});
						canvas.discardActiveGroup();

					}*/;

				},
				bottom	: function(e) {

					var canvas = wpr.canvas,
						obj = canvas.getActiveObject(),
						grp = canvas.getActiveGroup();

					if(obj) {

						wpr.tool.move.bottom(obj);

					}/* else if(grp) {

						grp.forEachObject(function(obj){
							wpr.tool.move.bottom(obj);
						});
						canvas.discardActiveGroup();

					}*/;

				}
			},

			decrease	: {

				click	: function(e) {

					var height = wpr.canvas.getHeight();

					if(height>500) height -= 500;
					else window.alert('Высота холста минимальна.');

					wpr.canvas.setHeight(height);

				}

			},

			increase	: {

				click	: function(e) {

					var height = wpr.canvas.getHeight();

					if(height<5000) height += 500;
					else window.alert('Высота холста максимальна.');

					wpr.canvas.setHeight(height);

				}

			}

		};return w})(),


		tool	: (function(){var w={

			text	: {

				layer	: [],

				click	: function(e) {

					var color = ['#dfdfdf','#cfcfcf','#bfbfbf']

					var obj = new fabric.IText('Введите текст',{
							originX	: 'center',
							originY	: 'center',
							top		: wpr.viewbox.top + wpr.viewbox.height/2-62,
							left	: 500,
							hasRotatingPoint	: false,
							fontFamily	: 'Arial',
							backgroundColor		: color[w.text.layer.length]
						}),
						layer = w.text.layer,
						h = layer.length;

					wpr.canvas.add(obj);

					obj.moveTo(wpr.tool.frame.layer.length + wpr.tool.line.layer.length + wpr.tool.picture.layer.length + h);

					layer.push(obj);

				}

			},

			picture	: {

				layer	: [],

				obj		: false,

				click	: function(e) {

					wpr.modal.fade(false,'#modal-picture');

				}

			},

			line	: {

				layer	: [],

				click	: function(e) {

					var color = ['#f00','#0f0','#00f'];

					var obj = new fabric.Line([0,0,750,0], {
							originX	: 'center',
							originY	: 'center',
							top		: wpr.viewbox.top + wpr.viewbox.height/2-62,
							left	: 500,
							stroke	: color[w.line.layer.length],
							strokeWidth	: 2,
							hasRotatingPoint	: false,
							hasBorders			: false
							//lockScalingY		: true
						}).setControlsVisibility({
							tr: false,
							br: false,
							bl: false,
							tl: false,
							mt: false,
							mb: false
						}),
						layer = w.line.layer,
						h = layer.length;

					wpr.canvas.add(obj);

					obj.moveTo(wpr.tool.frame.layer.length + h);

					layer.push(obj);

				}

			},

			frame	: {

				layer	: [],

				click	: function(e) {

					var color = ['#ff0','#0ff','#f0f'];

					var obj = new fabric.Rect({
							originX	: 'center',
							originY	: 'center',
							top		: wpr.viewbox.top + wpr.viewbox.height/2-62,
							left	: 500,
							width	: 750,
							height	: 500,
							fill	: 'transparent',
							stroke	: color[w.frame.layer.length],
							strokeWidth	: 2,
							hasRotatingPoint	: false,
							hasBorders			: false
							//lockMovementX	: true,
							//lockMovementY	: true,
							//lockScalingX	: true,
							//lockScalingY	: true,
							//lockUniScaling	: true
						}).on('mousedown',w.frame.mousedown).on('scaling',w.frame.resize),
						layer = w.frame.layer,
						h = layer.length;

					wpr.canvas.add(obj);

					obj.moveTo(h);

					layer.push(obj);

				},

				mousedown	: function(opt) {

					var obj = wpr.canvas.getActiveObject(),
						data = w.frame.data;

					if(obj) {
						w.frame.data[0] = obj.getTop();
						w.frame.data[1] = obj.getLeft();
						/*w.frame.data[0][0] = x.getWidth();
						w.frame.data[1][0] = x.getHeight();
						w.frame.data[0][1] = opt.e.layerX;
						w.frame.data[1][1] = opt.e.layerY;*/
					};
					//console.log(opt);

				},

				resize	: function(opt) {

					var obj = wpr.canvas.getActiveObject(),
						data = w.frame.data,
						//top = x.getTop(),
						//left = x.getLeft(),
						width = obj.getScaleX() * obj.getWidth(),
						height = obj.getScaleY() * obj.getHeight();

					//console.log(data);

					if(obj) {
						obj.setScaleX(1)
							.setScaleY(1)
							//.setWidth(data[0][0]-(data[0][1]-opt.e.layerX)*2)
							.setWidth(width)
							.setHeight(height)
							.setTop(data[0])
							.setLeft(data[1]);
					};

				},

				data	: []

			},

			delete	: function(obj) {

				var frame = wpr.tool.frame.layer,
					line = wpr.tool.line.layer,
					picture = wpr.tool.picture.layer,
					text = wpr.tool.text.layer;

				wpr.canvas.remove(obj);

				     if(obj.isType('rect'))    frame.delete(obj);
				else if(obj.isType('line'))     line.delete(obj);
				else if(obj.isType('image')) picture.delete(obj);
				else if(obj.isType('i-text'))   text.delete(obj);

			},

			move	: {

				up	: function (obj) {

					var frame = wpr.tool.frame.layer,
						line = wpr.tool.line.layer,
						picture = wpr.tool.picture.layer,
						text = wpr.tool.text.layer,
						i = wpr.canvas.getObjects().indexOf(obj);

					//console.log(i);

					if (obj.isType('rect')) {

						if (i < frame.length - 1) obj.bringForward();
						frame.moveUp(obj);

					} else if (obj.isType('line')) {

						if (i < frame.length + line.length - 1) obj.bringForward();
						line.moveUp(obj);

					} else if (obj.isType('image')) {

						if (i < frame.length + line.length + picture.length - 1) obj.bringForward();
						picture.moveUp(obj);

					} else if (obj.isType('i-text')) {

						if (i < frame.length + line.length + picture.length + text.length - 1) obj.bringForward();
						text.moveUp(obj);

					};

					//console.log(wpr.canvas.getObjects().indexOf(obj));

				},
				down	: function(obj) {

					var frame = wpr.tool.frame.layer,
						line = wpr.tool.line.layer,
						picture = wpr.tool.picture.layer,
						text = wpr.tool.text.layer,
						i = wpr.canvas.getObjects().indexOf(obj);

					//console.log(i);

					if(obj.isType('rect')) {

						if(i > 0) obj.sendBackwards();
						frame.moveDown(obj);

					} else if(obj.isType('line')) {

						if(i > frame.length) obj.sendBackwards();
						line.moveDown(obj);

					} else if(obj.isType('image')) {

						if(i > frame.length+line.length) obj.sendBackwards();
						picture.moveDown(obj);

					} else if(obj.isType('i-text')) {

						if(i > frame.length+line.length+picture.length) obj.sendBackwards();
						text.moveDown(obj);

					};

					//console.log(wpr.canvas.getObjects().indexOf(obj));

				},
				top	: function(obj) {

					var frame = wpr.tool.frame.layer,
						line = wpr.tool.line.layer,
						picture = wpr.tool.picture.layer,
						text = wpr.tool.text.layer,
						i = wpr.canvas.getObjects().indexOf(obj);

					//console.log(i);

					if(obj.isType('rect')) {

						while(i < frame.length-1) {
							obj.bringForward();
							i = wpr.canvas.getObjects().indexOf(obj);
						};
						frame.moveTop(obj);

					} else if(obj.isType('line')) {

						while(i < frame.length+line.length-1) {
							obj.bringForward();
							i = wpr.canvas.getObjects().indexOf(obj);
						};
						line.moveTop(obj);

					} else if(obj.isType('image')) {

						while(i < frame.length+line.length+picture.length-1) {
							obj.bringForward();
							i = wpr.canvas.getObjects().indexOf(obj);
						};
						picture.moveTop(obj);

					} else if(obj.isType('i-text')) {

						while(i < frame.length+line.length+picture.length+text.length-1) {
							obj.bringForward();
							i = wpr.canvas.getObjects().indexOf(obj);
						};
						text.moveTop(obj);

					};

					//console.log(wpr.canvas.getObjects().indexOf(obj));

				},
				bottom	: function(obj) {

					var frame = wpr.tool.frame.layer,
						line = wpr.tool.line.layer,
						picture = wpr.tool.picture.layer,
						text = wpr.tool.text.layer,
						i = wpr.canvas.getObjects().indexOf(obj);

					//console.log(i);

					if(obj.isType('rect')) {

						while(i > 0) {
							obj.sendBackwards();
							i = wpr.canvas.getObjects().indexOf(obj);
						};
						frame.moveBottom(obj);

					} else if(obj.isType('line')) {

						while(i > frame.length) {
							obj.sendBackwards();
							i = wpr.canvas.getObjects().indexOf(obj);
						};
						line.moveBottom(obj);

					} else if(obj.isType('image')) {

						while(i > frame.length+line.length) {
							obj.sendBackwards();
							i = wpr.canvas.getObjects().indexOf(obj);
						};
						picture.moveBottom(obj);

					} else if(obj.isType('i-text')) {

						while(i > frame.length+line.length+picture.length) {
							obj.sendBackwards();
							i = wpr.canvas.getObjects().indexOf(obj);
						};
						text.moveBottom(obj);

					};

					//console.log(wpr.canvas.getObjects().indexOf(obj));

				}

			}

		};return w})(),


		modal	: (function(){var w={

			orient	: function(top,height) {

				var modal = document.getElementById('modal-picture');

				modal.style.top = top + height/2 - (modal.offsetHeight?modal.offsetHeight:140)/2 + 'px';

			},

			fade	: function(b,s) {

				var o = $(s || '.modal:visible');

				if(b) {
					$('#fog').fadeOut(250);
					o.fadeOut(10);
				} else {
					$('#fog').fadeIn(10);
					o.fadeIn(250);
				};

			}

		};return w})()


	};



};


$(document).ready(function(){


	fabric.Group.prototype.setControlsVisibility({
		mtr: false
	});

	wpr.ready();

	var viewbox = wpr.viewbox,
		tool = wpr.tool,
		field = wpr.field,
		button = wpr.button,
		action = wpr.action;

	$('#fog,.modal .header .action.not').click(wpr.modal.fade);

	$('#tool-text'     ).click(tool.text.click);
	$('#tool-picture'  ).click(tool.picture.click);
	$('#tool-line'     ).click(tool.line.click);
	$('#tool-frame'    ).click(tool.frame.click);

	$('#field-picture' ).change(field.picture.change);
	$('#button-picture').click(button.picture.click);

	$('#action-delete'     ).click(action.delete);
	$('#action-move-up'    ).click(action.move.up);
	$('#action-move-down'  ).click(action.move.down);
	$('#action-move-top'   ).click(action.move.top);
	$('#action-move-bottom').click(action.move.bottom);
	$('#action-decrease'   ).click(action.decrease.click);
	$('#action-increase'   ).click(action.increase.click);
	$(window).keydown(action.delete);

	$(window).resize(viewbox.resize);
	$(window).scroll(viewbox.scroll);


	wpr.modal.orient(viewbox.top,viewbox.height);


});


Array.prototype.delete = function(item){
	//console.log(this);
	this.splice(this.indexOf(item),1);
	//console.log(this);
	return this;
};
Array.prototype.moveUp = function(item,to){
	//console.log(this);
	if(this.length>1) {
		var from = this.indexOf(item),
			to = to || from+1;
		this.splice(to,0,this.splice(from,1)[0]);
	};
	//console.log(this);
	return this;
};
Array.prototype.moveDown = function(item,to){
	//console.log(this);
	if(this.length>1) {
		var from = this.indexOf(item),
			to = to || from-1;
		this.splice(to,0,this.splice(from,1)[0]);
	};
	//console.log(this);
	return this;
};
Array.prototype.moveTop = function(item,to){
	//console.log(this);
	if(this.length>1) {
		var from = this.indexOf(item),
			to = to || this.length-1;
		this.splice(to,0,this.splice(from,1)[0]);
	};
	//console.log(this);
	return this;
};
Array.prototype.moveBottom = function(item,to){
	//console.log(this);
	if(this.length>1) {
		var from = this.indexOf(item),
			to = to || 0;
		this.splice(to,0,this.splice(from,1)[0]);
	};
	//console.log(this);
	return this;
};
